diff --git a/gcc/testsuite/g++.dg/ext/altivec-1.C b/gcc/testsuite/g++.target/powerpc/altivec-1.C
similarity index 83%
rename from gcc/testsuite/g++.dg/ext/altivec-1.C
rename to gcc/testsuite/g++.target/powerpc/altivec-1.C
index cd7c3aad2611..a809de2a3bf4 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-1.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-1.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-10.C b/gcc/testsuite/g++.target/powerpc/altivec-10.C
similarity index 92%
rename from gcc/testsuite/g++.dg/ext/altivec-10.C
rename to gcc/testsuite/g++.target/powerpc/altivec-10.C
index c36c3914b1ad..c9c475426113 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-10.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-10.C
@@ -1,6 +1,6 @@
 /* This is a compile-only test for interaction of "-maltivec" and "-save-temps".  */
 /* Author:  Ziemowit Laski  <zlaski@apple.com>.  */
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-save-temps -maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-11.C b/gcc/testsuite/g++.target/powerpc/altivec-11.C
similarity index 80%
rename from gcc/testsuite/g++.dg/ext/altivec-11.C
rename to gcc/testsuite/g++.target/powerpc/altivec-11.C
index ff3016953d87..c767715c8b61 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-11.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-11.C
@@ -1,5 +1,5 @@
 /* Test handling of literal constant for dss operation.  */
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-12.C b/gcc/testsuite/g++.target/powerpc/altivec-12.C
similarity index 87%
rename from gcc/testsuite/g++.dg/ext/altivec-12.C
rename to gcc/testsuite/g++.target/powerpc/altivec-12.C
index 6f21da961b28..f57923e7155d 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-12.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-12.C
@@ -1,5 +1,5 @@
 /* Test vec_dst* functions with float pointer as first argument.  */
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-13.C b/gcc/testsuite/g++.target/powerpc/altivec-13.C
similarity index 97%
rename from gcc/testsuite/g++.dg/ext/altivec-13.C
rename to gcc/testsuite/g++.target/powerpc/altivec-13.C
index abc05af62d5b..286d7789076a 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-13.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-13.C
@@ -2,7 +2,7 @@
    test is derived from parts of gcc.dg/vmx/8-02.c from Motorola's
    AltiVec testsuite.  */
 
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-14.C b/gcc/testsuite/g++.target/powerpc/altivec-14.C
similarity index 86%
rename from gcc/testsuite/g++.dg/ext/altivec-14.C
rename to gcc/testsuite/g++.target/powerpc/altivec-14.C
index 02e8a23258d2..8f4cb6af6529 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-14.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-14.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-15.C b/gcc/testsuite/g++.target/powerpc/altivec-15.C
similarity index 92%
rename from gcc/testsuite/g++.dg/ext/altivec-15.C
rename to gcc/testsuite/g++.target/powerpc/altivec-15.C
index 662d67890873..dc5d9552c365 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-15.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-15.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec -mno-vsx" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-16.C b/gcc/testsuite/g++.target/powerpc/altivec-16.C
similarity index 88%
rename from gcc/testsuite/g++.dg/ext/altivec-16.C
rename to gcc/testsuite/g++.target/powerpc/altivec-16.C
index 91230d26138b..cdfbc6d74aae 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-16.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-16.C
@@ -1,5 +1,5 @@
 // PR c++/36662
-// { dg-do compile { target powerpc*-*-* } }
+// { dg-do compile }
 // { dg-require-effective-target powerpc_altivec_ok }
 // { dg-options "-maltivec" }
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-17.C b/gcc/testsuite/g++.target/powerpc/altivec-17.C
similarity index 91%
rename from gcc/testsuite/g++.dg/ext/altivec-17.C
rename to gcc/testsuite/g++.target/powerpc/altivec-17.C
index 099f8742e783..d95ac16a6999 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-17.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-17.C
@@ -1,4 +1,4 @@
-// { dg-do compile { target powerpc*-*-* } }
+// { dg-do compile }
 // { dg-require-effective-target powerpc_altivec_ok }
 // { dg-options "-maltivec" }
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-18.C b/gcc/testsuite/g++.target/powerpc/altivec-18.C
similarity index 83%
rename from gcc/testsuite/g++.dg/ext/altivec-18.C
rename to gcc/testsuite/g++.target/powerpc/altivec-18.C
index 5b83028e7370..ddfca943c0c3 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-18.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-18.C
@@ -1,5 +1,5 @@
 // PR target/82112
-// { dg-do compile { target powerpc*-*-* } }
+// { dg-do compile }
 // { dg-require-effective-target powerpc_altivec_ok }
 // { dg-options "-maltivec" }
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-2.C b/gcc/testsuite/g++.target/powerpc/altivec-2.C
similarity index 92%
rename from gcc/testsuite/g++.dg/ext/altivec-2.C
rename to gcc/testsuite/g++.target/powerpc/altivec-2.C
index e14e6f800f78..b2eaf62a0ed1 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-2.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-2.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec -Wall -Wno-unused-but-set-variable -Wno-deprecated" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-3.C b/gcc/testsuite/g++.target/powerpc/altivec-3.C
similarity index 96%
rename from gcc/testsuite/g++.dg/ext/altivec-3.C
rename to gcc/testsuite/g++.target/powerpc/altivec-3.C
index 151132059508..522d62bd3ffd 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-3.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-3.C
@@ -1,5 +1,5 @@
-/* { dg-do run { target { powerpc*-*-* && vmx_hw } } } */
-/* { dg-do compile { target { powerpc*-*-* && { ! vmx_hw } } } } */
+/* { dg-do run { target { vmx_hw } } } */
+/* { dg-do compile { target { ! vmx_hw } } } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-4.C b/gcc/testsuite/g++.target/powerpc/altivec-4.C
similarity index 81%
rename from gcc/testsuite/g++.dg/ext/altivec-4.C
rename to gcc/testsuite/g++.target/powerpc/altivec-4.C
index 86a2615dc498..9ac1fbf38a38 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-4.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-4.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-5.C b/gcc/testsuite/g++.target/powerpc/altivec-5.C
similarity index 83%
rename from gcc/testsuite/g++.dg/ext/altivec-5.C
rename to gcc/testsuite/g++.target/powerpc/altivec-5.C
index 04c26e80ff45..d11f1fabd25a 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-5.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-5.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-6.C b/gcc/testsuite/g++.target/powerpc/altivec-6.C
similarity index 94%
rename from gcc/testsuite/g++.dg/ext/altivec-6.C
rename to gcc/testsuite/g++.target/powerpc/altivec-6.C
index d17fd90739ac..cfbfa4edc50a 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-6.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-6.C
@@ -1,6 +1,6 @@
 /* Test for correct handling of literal arguments. */
 /* Author: Ziemowit Laski  <zlaski@apple.com>  */
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-7.C b/gcc/testsuite/g++.target/powerpc/altivec-7.C
similarity index 96%
rename from gcc/testsuite/g++.dg/ext/altivec-7.C
rename to gcc/testsuite/g++.target/powerpc/altivec-7.C
index 038335433f42..de166879a167 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-7.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-7.C
@@ -1,5 +1,5 @@
 /* Test for AltiVec type overloading and name mangling.  */
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-8.C b/gcc/testsuite/g++.target/powerpc/altivec-8.C
similarity index 93%
rename from gcc/testsuite/g++.dg/ext/altivec-8.C
rename to gcc/testsuite/g++.target/powerpc/altivec-8.C
index 3c5a76e060e8..2a5891ca0cfc 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-8.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-8.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 /* Author: Ziemowit Laski  <zlaski@apple.com>  */
diff --git a/gcc/testsuite/g++.dg/ext/altivec-9.C b/gcc/testsuite/g++.target/powerpc/altivec-9.C
similarity index 86%
rename from gcc/testsuite/g++.dg/ext/altivec-9.C
rename to gcc/testsuite/g++.target/powerpc/altivec-9.C
index 174ae63edcb7..6f07bdf30270 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-9.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-9.C
@@ -1,5 +1,5 @@
 /* Test for AltiVec function vec_ld, passing a pointer to const vector */
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-cell-1.C b/gcc/testsuite/g++.target/powerpc/altivec-cell-1.C
similarity index 96%
rename from gcc/testsuite/g++.dg/ext/altivec-cell-1.C
rename to gcc/testsuite/g++.target/powerpc/altivec-cell-1.C
index 16d311c3bef5..cdef3222ad91 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-cell-1.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-cell-1.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-cell-2.C b/gcc/testsuite/g++.target/powerpc/altivec-cell-2.C
similarity index 94%
rename from gcc/testsuite/g++.dg/ext/altivec-cell-2.C
rename to gcc/testsuite/g++.target/powerpc/altivec-cell-2.C
index f0d3433cdd99..9601545913b4 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-cell-2.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-cell-2.C
@@ -1,5 +1,5 @@
-/* { dg-do run { target { powerpc*-*-* && vmx_hw } } } */
-/* { dg-do compile { target { powerpc*-*-* && { ! vmx_hw } } } } */
+/* { dg-do run { target { vmx_hw } } } */
+/* { dg-do compile { target { ! vmx_hw } } } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 /* Test the vec_extract VMX intrinsics.  */
diff --git a/gcc/testsuite/g++.dg/ext/altivec-cell-3.C b/gcc/testsuite/g++.target/powerpc/altivec-cell-3.C
similarity index 85%
rename from gcc/testsuite/g++.dg/ext/altivec-cell-3.C
rename to gcc/testsuite/g++.target/powerpc/altivec-cell-3.C
index bd7e774e3cdc..76624009c69e 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-cell-3.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-cell-3.C
@@ -1,5 +1,5 @@
-/* { dg-do run { target { powerpc*-*-* && vmx_hw } } } */
-/* { dg-do compile { target { powerpc*-*-* && { ! vmx_hw } } } } */
+/* { dg-do run { target { vmx_hw } } } */
+/* { dg-do compile { target { ! vmx_hw } } } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 /* Test the vec_splats and vec_promote VMX intrinsics.  */
diff --git a/gcc/testsuite/g++.dg/ext/altivec-cell-4.C b/gcc/testsuite/g++.target/powerpc/altivec-cell-4.C
similarity index 88%
rename from gcc/testsuite/g++.dg/ext/altivec-cell-4.C
rename to gcc/testsuite/g++.target/powerpc/altivec-cell-4.C
index 7d91adbb34e7..cbe779724046 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-cell-4.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-cell-4.C
@@ -1,5 +1,5 @@
-/* { dg-do run { target { powerpc*-*-* && vmx_hw } } } */
-/* { dg-do compile { target { powerpc*-*-* && { ! vmx_hw } } } } */
+/* { dg-do run { target { vmx_hw } } } */
+/* { dg-do compile { target { ! vmx_hw } } } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-cell-5.C b/gcc/testsuite/g++.target/powerpc/altivec-cell-5.C
similarity index 96%
rename from gcc/testsuite/g++.dg/ext/altivec-cell-5.C
rename to gcc/testsuite/g++.target/powerpc/altivec-cell-5.C
index 7e5bc78d5685..13320f6537c1 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-cell-5.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-cell-5.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-types-1.C b/gcc/testsuite/g++.target/powerpc/altivec-types-1.C
similarity index 98%
rename from gcc/testsuite/g++.dg/ext/altivec-types-1.C
rename to gcc/testsuite/g++.target/powerpc/altivec-types-1.C
index afcd5693d80d..fe8e11fe07b1 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-types-1.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-types-1.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-linux* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec -mno-vsx -std=c++98" } */
 
diff --git a/gcc/testsuite/g++.dg/ext/altivec-types-2.C b/gcc/testsuite/g++.target/powerpc/altivec-types-2.C
similarity index 92%
rename from gcc/testsuite/g++.dg/ext/altivec-types-2.C
rename to gcc/testsuite/g++.target/powerpc/altivec-types-2.C
index 4df12da0b195..44b557e92a11 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-types-2.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-types-2.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-linux* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target ilp32 } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec -mno-vsx" } */
diff --git a/gcc/testsuite/g++.dg/ext/altivec-types-3.C b/gcc/testsuite/g++.target/powerpc/altivec-types-3.C
similarity index 92%
rename from gcc/testsuite/g++.dg/ext/altivec-types-3.C
rename to gcc/testsuite/g++.target/powerpc/altivec-types-3.C
index 755de736477c..8cb41394e2dd 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-types-3.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-types-3.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-linux* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-require-effective-target lp64 } */
 /* { dg-options "-maltivec -mno-vsx" } */
diff --git a/gcc/testsuite/g++.dg/ext/altivec-types-4.C b/gcc/testsuite/g++.target/powerpc/altivec-types-4.C
similarity index 89%
rename from gcc/testsuite/g++.dg/ext/altivec-types-4.C
rename to gcc/testsuite/g++.target/powerpc/altivec-types-4.C
index b937f3cf1b1e..86592da7100c 100644
--- a/gcc/testsuite/g++.dg/ext/altivec-types-4.C
+++ b/gcc/testsuite/g++.target/powerpc/altivec-types-4.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target powerpc*-*-linux* } } */
+/* { dg-do compile } */
 /* { dg-require-effective-target ilp32 } */
 /* { dg-require-effective-target powerpc_altivec_ok } */
 /* { dg-options "-maltivec -mno-vsx -mno-warn-altivec-long" } */
diff --git a/gcc/testsuite/g++.dg/ext/undef-bool-1.C b/gcc/testsuite/g++.target/powerpc/undef-bool-1.C
similarity index 85%
rename from gcc/testsuite/g++.dg/ext/undef-bool-1.C
rename to gcc/testsuite/g++.target/powerpc/undef-bool-1.C
index 9cc1cd872609..d9a1eb5aa85e 100644
--- a/gcc/testsuite/g++.dg/ext/undef-bool-1.C
+++ b/gcc/testsuite/g++.target/powerpc/undef-bool-1.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target { powerpc*-*-* } } } */
+/* { dg-do compile } */
 /* { dg-options "-O2 -DNO_WARN_X86_INTRINSICS -mvsx" } */
 /* { dg-require-effective-target lp64 } */
 /* { dg-require-effective-target powerpc_vsx_ok } */