diff --git a/gcc/testsuite/g++.dg/pr65240-1.C b/gcc/testsuite/g++.target/powerpc/pr65240-1.C
similarity index 76%
rename from gcc/testsuite/g++.dg/pr65240-1.C
rename to gcc/testsuite/g++.target/powerpc/pr65240-1.C
index d2e25b65fcae..d2f4a229773e 100644
--- a/gcc/testsuite/g++.dg/pr65240-1.C
+++ b/gcc/testsuite/g++.target/powerpc/pr65240-1.C
@@ -1,5 +1,5 @@
-/* { dg-do compile { target { powerpc*-*-* && lp64 } } } */
-/* { dg-skip-if "" { powerpc*-*-darwin* } } */
+/* { dg-do compile { target lp64 } } */
+/* { dg-skip-if "" { *-*-darwin* } } */
 /* { dg-require-effective-target powerpc_p8vector_ok } */
 /* { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power8" } } */
 /* { dg-options "-mcpu=power8 -O3 -ffast-math -mcmodel=small -mno-fp-in-toc -Wno-return-type" } */
diff --git a/gcc/testsuite/g++.dg/pr65240-2.C b/gcc/testsuite/g++.target/powerpc/pr65240-2.C
similarity index 76%
rename from gcc/testsuite/g++.dg/pr65240-2.C
rename to gcc/testsuite/g++.target/powerpc/pr65240-2.C
index 38d5020bd198..12e36994d27b 100644
--- a/gcc/testsuite/g++.dg/pr65240-2.C
+++ b/gcc/testsuite/g++.target/powerpc/pr65240-2.C
@@ -1,5 +1,5 @@
-/* { dg-do compile { target { powerpc*-*-* && lp64 } } } */
-/* { dg-skip-if "" { powerpc*-*-darwin* } } */
+/* { dg-do compile { target lp64 } } */
+/* { dg-skip-if "" { *-*-darwin* } } */
 /* { dg-require-effective-target powerpc_p8vector_ok } */
 /* { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power8" } } */
 /* { dg-options "-mcpu=power8 -O3 -ffast-math -mcmodel=small -mfp-in-toc -Wno-return-type" } */
diff --git a/gcc/testsuite/g++.dg/pr65240-3.C b/gcc/testsuite/g++.target/powerpc/pr65240-3.C
similarity index 76%
rename from gcc/testsuite/g++.dg/pr65240-3.C
rename to gcc/testsuite/g++.target/powerpc/pr65240-3.C
index e8463c914946..9ded3e3ab1d3 100644
--- a/gcc/testsuite/g++.dg/pr65240-3.C
+++ b/gcc/testsuite/g++.target/powerpc/pr65240-3.C
@@ -1,5 +1,5 @@
-/* { dg-do compile { target { powerpc*-*-* && lp64 } } } */
-/* { dg-skip-if "" { powerpc*-*-darwin* } } */
+/* { dg-do compile { target lp64 } } */
+/* { dg-skip-if "" { *-*-darwin* } } */
 /* { dg-require-effective-target powerpc_p8vector_ok } */
 /* { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power8" } } */
 /* { dg-options "-mcpu=power8 -O3 -ffast-math -mcmodel=medium -Wno-return-type" } */
diff --git a/gcc/testsuite/g++.dg/pr65240-4.C b/gcc/testsuite/g++.target/powerpc/pr65240-4.C
similarity index 75%
rename from gcc/testsuite/g++.dg/pr65240-4.C
rename to gcc/testsuite/g++.target/powerpc/pr65240-4.C
index a119752d18e4..069a2e23add3 100644
--- a/gcc/testsuite/g++.dg/pr65240-4.C
+++ b/gcc/testsuite/g++.target/powerpc/pr65240-4.C
@@ -1,5 +1,5 @@
-/* { dg-do compile { target { powerpc*-*-* && lp64 } } } */
-/* { dg-skip-if "" { powerpc*-*-darwin* } } */
+/* { dg-do compile { target lp64 } } */
+/* { dg-skip-if "" { *-*-darwin* } } */
 /* { dg-require-effective-target powerpc_vsx_ok } */
 /* { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power7" } } */
 /* { dg-options "-mcpu=power7 -O3 -ffast-math -Wno-return-type" } */
diff --git a/gcc/testsuite/g++.dg/pr65240.h b/gcc/testsuite/g++.target/powerpc/pr65240.h
similarity index 100%
rename from gcc/testsuite/g++.dg/pr65240.h
rename to gcc/testsuite/g++.target/powerpc/pr65240.h
diff --git a/gcc/testsuite/g++.dg/pr65242.C b/gcc/testsuite/g++.target/powerpc/pr65242.C
similarity index 94%
rename from gcc/testsuite/g++.dg/pr65242.C
rename to gcc/testsuite/g++.target/powerpc/pr65242.C
index be2ddaa85b23..22576daac7db 100644
--- a/gcc/testsuite/g++.dg/pr65242.C
+++ b/gcc/testsuite/g++.target/powerpc/pr65242.C
@@ -1,5 +1,5 @@
-/* { dg-do compile { target { powerpc*-*-* && lp64 } } } */
-/* { dg-skip-if "" { powerpc*-*-darwin* } } */
+/* { dg-do compile { target lp64 } } */
+/* { dg-skip-if "" { *-*-darwin* } } */
 /* { dg-require-effective-target powerpc_p8vector_ok } */
 /* { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power8" } } */
 /* { dg-options "-mcpu=power8 -O3" } */
diff --git a/gcc/testsuite/g++.dg/pr67211.C b/gcc/testsuite/g++.target/powerpc/pr67211.C
similarity index 92%
rename from gcc/testsuite/g++.dg/pr67211.C
rename to gcc/testsuite/g++.target/powerpc/pr67211.C
index cb3d342c122d..a9298b8d119a 100644
--- a/gcc/testsuite/g++.dg/pr67211.C
+++ b/gcc/testsuite/g++.target/powerpc/pr67211.C
@@ -1,5 +1,5 @@
-/* { dg-do compile { target { powerpc*-*-* && lp64 } } } */
-/* { dg-skip-if "" { powerpc*-*-darwin* } } */
+/* { dg-do compile { target lp64 } } */
+/* { dg-skip-if "" { *-*-darwin* } } */
 /* { dg-require-effective-target powerpc_p8vector_ok } */
 /* { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power7" } } */
 /* { dg-options "-mcpu=power7 -mtune=power8 -O3 -w" } */
diff --git a/gcc/testsuite/g++.dg/pr69667.C b/gcc/testsuite/g++.target/powerpc/pr69667.C
similarity index 97%
rename from gcc/testsuite/g++.dg/pr69667.C
rename to gcc/testsuite/g++.target/powerpc/pr69667.C
index 76f7cb3d40b3..8b94ea4eca0e 100644
--- a/gcc/testsuite/g++.dg/pr69667.C
+++ b/gcc/testsuite/g++.target/powerpc/pr69667.C
@@ -1,5 +1,5 @@
-/* { dg-do compile { target { powerpc*-*-* && lp64 } } } */
-/* { dg-skip-if "" { powerpc*-*-darwin* } } */
+/* { dg-do compile { target lp64 } } */
+/* { dg-skip-if "" { *-*-darwin* } } */
 /* { dg-require-effective-target powerpc_p8vector_ok } */
 /* { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power7" } } */
 /* { dg-options "-mcpu=power8 -w -std=c++14" } */
diff --git a/gcc/testsuite/g++.dg/pr71294.C b/gcc/testsuite/g++.target/powerpc/pr71294.C
similarity index 96%
rename from gcc/testsuite/g++.dg/pr71294.C
rename to gcc/testsuite/g++.target/powerpc/pr71294.C
index 67675dd7e306..3b77f982dfa7 100644
--- a/gcc/testsuite/g++.dg/pr71294.C
+++ b/gcc/testsuite/g++.target/powerpc/pr71294.C
@@ -1,4 +1,4 @@
-// { dg-do compile { target { powerpc64*-*-* && lp64 } } }
+// { dg-do compile { target lp64 } }
 // { dg-require-effective-target powerpc_p8vector_ok } */
 // { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power8" } }
 // { dg-options "-mcpu=power8 -O3 -fstack-protector" }
diff --git a/gcc/testsuite/g++.dg/pr84264.C b/gcc/testsuite/g++.target/powerpc/pr84264.C
similarity index 79%
rename from gcc/testsuite/g++.dg/pr84264.C
rename to gcc/testsuite/g++.target/powerpc/pr84264.C
index 4f8a77d8ac41..c9968cf66aa7 100644
--- a/gcc/testsuite/g++.dg/pr84264.C
+++ b/gcc/testsuite/g++.target/powerpc/pr84264.C
@@ -1,4 +1,4 @@
-/* { dg-do compile { target { powerpc*-*-* } } } */
+/* { dg-do compile } */
 /* { dg-options "-w -O1 -fstack-protector-strong" } */
 
 void _setjmp ();
diff --git a/gcc/testsuite/g++.dg/pr84279.C b/gcc/testsuite/g++.target/powerpc/pr84279.C
similarity index 91%
rename from gcc/testsuite/g++.dg/pr84279.C
rename to gcc/testsuite/g++.target/powerpc/pr84279.C
index b2b5b8eabab1..ff71fd5eacef 100644
--- a/gcc/testsuite/g++.dg/pr84279.C
+++ b/gcc/testsuite/g++.target/powerpc/pr84279.C
@@ -1,5 +1,5 @@
-/* { dg-do compile { target { powerpc*-*-* } } } */
-/* { dg-skip-if "" { powerpc*-*-darwin* } } */
+/* { dg-do compile } */
+/* { dg-skip-if "" { *-*-darwin* } } */
 /* { dg-require-effective-target powerpc_p8vector_ok } */
 /* { dg-require-effective-target fpic } */
 /* { dg-skip-if "do not override -mcpu" { powerpc*-*-* } { "-mcpu=*" } { "-mcpu=power8" } } */
diff --git a/gcc/testsuite/g++.dg/pr85657.C b/gcc/testsuite/g++.target/powerpc/pr85657.C
similarity index 90%
rename from gcc/testsuite/g++.dg/pr85657.C
rename to gcc/testsuite/g++.target/powerpc/pr85657.C
index e62b62abcc5a..3a386542154d 100644
--- a/gcc/testsuite/g++.dg/pr85657.C
+++ b/gcc/testsuite/g++.target/powerpc/pr85657.C
@@ -1,4 +1,4 @@
-// { dg-do compile { target { powerpc*-*-linux* } } }
+// { dg-do compile { target { *-*-linux* } } }
 // { dg-require-effective-target ppc_float128_sw }
 // { dg-options "-mvsx -mfloat128 -O2 -mabi=ibmlongdouble -Wno-psabi" }
 
diff --git a/gcc/testsuite/g++.dg/pr93974.C b/gcc/testsuite/g++.target/powerpc/pr93974.C
similarity index 100%
rename from gcc/testsuite/g++.dg/pr93974.C
rename to gcc/testsuite/g++.target/powerpc/pr93974.C